package ec.app.sequence;

import java.io.FileReader;
import java.io.IOException;
import java.io.LineNumberReader;
import java.util.Hashtable;

import ec.EvolutionState;
import ec.Group;
import ec.Individual;
import ec.Subpopulation;
/**
 * This class extends Subpopulation and decreases the size of it every time 
 * by 25% for example.
 * @author udaykamath
 *
 */
public class SubpopulationExt extends Subpopulation{
	static int generation =0;
	
	 public Group emptyClone()
    {
        try
            {
            Subpopulation p = (Subpopulation)clone();
            p.species = species;  // don't throw it away...maybe this is a bad idea...
            int totalNumberOfIndividuals = (int)(individuals.length -0.25*individuals.length);
            p.individuals = new Individual[totalNumberOfIndividuals];  // empty
            return p;   
            }
        catch (CloneNotSupportedException e) { throw new InternalError(); } // never happens
        }
	
	 public void populate(EvolutionState state, int thread)
     {
     // should we load individuals from a file? -- duplicates are permitted
     if (loadInds!=null)
         {
         try { readSubpopulation(state, new LineNumberReader(new FileReader(loadInds))); }
         catch (IOException e) { state.output.fatal("An IOException occurred when trying to read from the file " + loadInds + ".  The IOException was: \n" + e); }
         }
     else
         {
    	
         Hashtable h = null;
         if (numDuplicateRetries >= 1)
             h = new Hashtable(individuals.length / 2);  // seems reasonable

         for(int x=0;x<individuals.length;x++) 
             {
             for(int tries=0; 
                 tries <= /* Yes, I see that*/ numDuplicateRetries; 
                 tries++)
                 {
                 individuals[x] = species.newIndividual(state, thread);

                 if (numDuplicateRetries >= 1)
                     {
                     // check for duplicates
                     Object o = h.get(individuals[x]);
                     if (o == null) // found nothing, we're safe
                         // hash it and go
                         {
                         h.put(individuals[x],individuals[x]);
                         break;
                         }
                     }
                 }  // oh well, we tried to cut down the duplicates
             }
             generation ++;
         }
     }
}
