package ec.app.sequence.func;

import ec.EvolutionState;
import ec.Problem;
import ec.app.sequence.MotifData;
import ec.gp.ADFStack;
import ec.gp.GPData;
import ec.gp.GPIndividual;
import ec.gp.GPNode;
import ec.util.Parameter;
/**
 * Dummy boolean terminal needed for closure in Tree Generation.
 * @author udaykamath
 *
 */
public class BooleanTrueTerminal extends GPNode{
    public String toString() { return "true"; }

    public void checkConstraints(final EvolutionState state,
        final int tree,
        final GPIndividual typicalIndividual,
        final Parameter individualBase)
        {
        super.checkConstraints(state,tree,typicalIndividual,individualBase);
        if (children.length!=0)
            state.output.error("Incorrect number of children for node " + 
                toStringForError() + " at " +
                individualBase);
        }

    public void eval(final EvolutionState state,
        final int thread,
        final GPData input,
        final ADFStack stack,
        final GPIndividual individual,
        final Problem problem)
        {
    	MotifData motifData = ((MotifData) (input));
        motifData.matches = true;
        }
    
}
